<?php
/**
 * @version    4.0.1
 * @package     com_mymaplocations
 * @copyright   JoomUnited (C) 2011. All rights reserved.
 * @license     http://www.gnu.org/copyleft/gpl.html GNU/GPL
 */
// No direct access
defined('_JEXEC') or die('Restricted access');

if(!@include_once(rtrim(JPATH_SITE,DIRECTORY_SEPARATOR).DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_mymaplocations'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'mymaplocations.php')){
	return;
};
JTable::addIncludePath(JPATH_ADMINISTRATOR . DIRECTORY_SEPARATOR . 'components' . DIRECTORY_SEPARATOR. 'com_mymaplocations' . DIRECTORY_SEPARATOR . 'tables');
$_PLUGINS->registerFunction( 'onAfterDeleteUser', 'userDelete','getMyMaplocationsTab' );
$_PLUGINS->registerUserFieldParams();

class getMyMaplocationsTab extends cbTabHandler {

	var $installed = true;
	var $errorMessage = 'This plugin can not work without the My Map Locations Component.<br/>';

	public function __construct(){
		if(!class_exists('MyMaplocationsHelper')){
			$this->installed = false;
		}

		$this->cbTabHandler();
	}

	function getDisplayRegistration($tab, $user, $ui, $postdata) {
		MyMaplocationsHelper::loadLanguage();
		$return = array();
		$html=$this->getMMLField();
		$label=$tab->title;
		$return[] = cbTabs::_createPseudoField( $tab, $label, $html, '', '', false );
		return $return;
	}
	
	function getMMLField($id=null)
	{
		$html="";
		$extension = 'com_mymaplocations';
		$form = JForm::getInstance('form', JPATH_ADMINISTRATOR . '/components/com_mymaplocations/models/forms/location.xml');
		 MyMaplocationsHelper::loadLanguage();
		$result=array();
		$autogeocode=$this->params->get('autogeocode');
		$params=JComponentHelper::getParams('com_mymaplocations');
		$googleapi=$params->get('googleapi','AIzaSyDyJXSfY3iyCQCku7oKqFiZMOV6aFXQxls');
		if($googleapi){
				$key='&amp;key='.$googleapi;
				}
		 
		if($id!=null)
		{
		$db = JFactory::getDBO();
            $sql = "select * from #__mymaplocations_location where component=" . $db->Quote('com_comprofiler') . "AND extra_id=" . $db->Quote($id);
            $db->setQuery($sql);
            $result = $db->loadObject();
		}
		if (!empty($result)) {
                $form->bind($result);
                $latlng = $result->latitude . "," . $result->longitude;
            } else {
                $latlng = "44.824708,-0.615234";
            }
	    if($autogeocode==1)
	    { if(method_exists('MyMapLocationsHelper','getBackEndJs'))
               {
                $script="";
                  if ((@$result->latitude)) {
                 MyMaplocationsHelper::getBackEndJs(false,$result->latitude ,$result->longitude);
                } else {
                 MyMaplocationsHelper::getBackEndJs(false);
                              }
               }else {
		$script = <<<EOF
	      <style type="text/css">
		  .mymaplocation input
		  {
			min-height:30px;
		  }
		  </style>
              <script type="text/javascript">
      var latlng = new google.maps.LatLng($latlng);
      var options = {
          zoom: 5,
          center: latlng,
          mapTypeId: google.maps.MapTypeId.ROADMAP,
          draggableCursor: "crosshair",
          streetViewControl: false
        };
      var map = new google.maps.Map(document.getElementById("map"), options);
      jQuery("#zoom").html(5);
		  google.maps.event.addListener(map,"click", function(location)
      {
        GetlocationInfo(location.latLng);
      });
      google.maps.event.addListener(map,'zoom_changed', function(oldLevel, newLevel)
      {
        jQuery("#zoom").html(map.getZoom());
      });
      var myPano = new google.maps.StreetViewPanorama(document.getElementById("pano"),
            { visible:false});
      myPano.setPov({
        heading: 265,
        zoom:1,
        pitch:0});
      jQuery('#pano').hide();
      google.maps.event.trigger(myPano, 'resize');

			// autocomplete
			var autocomplete = new google.maps.places.Autocomplete(document.getElementById('postcode'), {});
			google.maps.event.addListener(autocomplete, 'place_changed', function() {
				jQuery("#locations").html("");
				jQuery("#error").html("");
				var place = autocomplete.getPlace();
				Gotolocation(place.geometry.location);
			});

      var initListener;
      var marker;
      function StartStreetView() {
        // street view
        if (jQuery("#streetViewBtn").val() == "Start StreetView") {
          initListener = google.maps.event.addListener(myPano, "position_changed", handlePanoMove);
          jQuery('#pano').show();
          myPano.setVisible(true);
          jQuery("#streetViewBtn").val("End StreetView");
          google.maps.event.trigger(myPano, 'resize');
          GotoLatLong();
        }
        else {
          google.maps.event.removeListener(initListener);
          myPano.setVisible(false);
          jQuery('#pano').hide();
          jQuery("#streetViewBtn").val("Start StreetView");
          google.maps.event.trigger(myPano, 'resize');
        }
      }

			function Geocode()
			{
				jQuery("#locations").html("");
				jQuery("#error").html("");
				// geocode with google.maps.Geocoder
				var localSearch = new google.maps.Geocoder();
				var postcode = jQuery("#postcode").val();
				localSearch.geocode({ 'address': postcode },
					function(results, status) {
						if (results.length == 1) {
							var result = results[0];
							var location = result.geometry.location;
							Gotolocation(location);
						}
						else if (results.length > 1) {
							jQuery("#error").html("Multiple addresses found");
							// build a list of possible addresses
							var html = "";
							for (var i=0; i<results.length; i++) {
								html += '<a href="javascript:Gotolocation(new google.maps.LatLng(' +
									results[i].geometry.location.lat() + ', ' + results[i].geometry.location.lng() + '))">' +
									results[i].formatted_address + "</a><br/>";
							}
							jQuery("#locations").html(html);
						}
						else {
							jQuery("#error").html("Address not found");
						}
					});
			}
			function useGeocode()
			{
				if (navigator.geolocation)
					{
						navigator.geolocation.getCurrentPosition(showPosition);
					}
				else
				{
					x.innerHTML="Geolocation is not supported by this browser.";
				}
			}
			function showPosition(position)
			{
				document.getElementById('latitude').value= position.coords.latitude;
				document.getElementById('longitude').value=position.coords.longitude;
				ReverseGeocoding(position.coords.latitude, position.coords.longitude, '#address_text');
				Gotolocation(new google.maps.LatLng( position.coords.latitude, position.coords.longitude));
				
			}
			

			function Gotolocation(location) {
				GetlocationInfo(location);
				map.setCenter(location);
			}

      function GetlocationInfo(latlng)
      {
        if (latlng != null)
        {
          ShowLatLong(latlng);
          UpdateStreetView(latlng);
        }
      }

      function GotoLatLong()
      {
        if (jQuery("#lat").val() != "" && jQuery("#long").val() != "") {
          var lat = jQuery("#lat").val();
          var long = jQuery("#long").val();
          var latLong = new google.maps.LatLng(lat, long);
          ShowLatLong(latLong);
          map.setCenter(latLong);
          UpdateStreetView(latLong);
        }
      }

      function ShowLink(){
        jQuery("#mapLink").html('<a href="https://maps.google.com/?ll=' + jQuery("#lat").val() +
          ',' + jQuery("#long").val() + '&z=' + jQuery("#zoom").html() + '">Link for this map</a>');
      }

			function toDMS(latOrLng) {
				var d = parseInt(latOrLng);
				var md = Math.abs(latOrLng - d) * 60;
				var m = Math.floor(md);
				var sd = (md - m) * 60;
				return Math.abs(d) + "\u00B0 " + m + "' " + roundNumber(sd, 4) + '"';
			}

			function latToDMS(lat) {
				var dms = toDMS(lat);
				if (lat > 0)
					return dms + "N";
				else
					return dms + "S";
			}

			function lngToDMS(lng) {
				var dms = toDMS(lng);
				if (lng > 0)
					return dms + "E";
				else
					return dms + "W";
			}

      function ShowLatLong(latLong)
      {
        // show the lat/long
        if (marker != null) {
          marker.setMap(null);
        }
        marker = new google.maps.Marker({
          position: latLong,
          map: map});
        jQuery("#latitude").val(roundNumber(latLong.lat(), 6));
        jQuery("#longitude").val(roundNumber(latLong.lng(), 6));
				jQuery("#latDMS").html(latToDMS(latLong.lat()));
				jQuery("#lngDMS").html(lngToDMS(latLong.lng()));
        ShowLink();
        GetElevation(latLong.lat(), latLong.lng(), '#elevation');
        ReverseGeocoding(latLong.lat(), latLong.lng(), '#address_text');
      }
function ReverseGeocoding(lat, long, selector){
    var geocoder = new google.maps.Geocoder();
    var latLong = new google.maps.LatLng(lat, long);
    var streetNumber = '';
            var streetName = '';
            var country = '';
            var postalCode = '';
            var city = '';
	    var estate='';
    geocoder.geocode({'latLng': latLong}, function(results, status) {
      if (status == google.maps.GeocoderStatus.OK) {
        if (results) {
         
          var foundAddress = false;
          for (var i=0; i<results.length; i++) {
            if ((results[i].types[0] == 'street_address') || (results[i].types[0] == 'route')) {
              results[i].address_components.each(function (el) {

                    el.types.each(function (type) {
                        if (type == 'street_number') {
                            streetNumber = el.long_name;
                        }

                        if (type == 'route') {
                            streetName = el.long_name;
                        }
			if (type == 'administrative_area_level_1') {
                            estate = el.long_name;
                        }
                        if (type == 'country') {
                            country = el.long_name;
                        }

                        if (type == 'postal_code') {
                            postalCode = el.long_name;
                        }

                        if (type == 'locality') {
                            city = el.long_name;
                        }
                    })
                });
		 jQuery("#address").val(streetNumber+" "+streetName);
		 jQuery("#town").val(city);
		 jQuery("#country").val(country);
		 jQuery("#postal").val(postalCode);
		 jQuery("#locationstate").val(estate);
              foundAddress = true;
	      break;
            }
          }
          if (!foundAddress) {
             jQuery("#jform_address").html(results[0].formatted_address);
          }
        }
      }
    });
  }

      function UpdateStreetView(latLong)
      {
        // street view
        if (jQuery("#streetViewBtn").val() == "End StreetView") {
          jQuery("#panoError").html("");
          myPano.setVisible(true);
          myPano.setPosition(latLong);
          // also set via the service API so we know if there is a view available
          var service = new google.maps.StreetViewService();
          service.getPanoramaBylocation(latLong, 50,
            function(result, status) {
              if (status != google.maps.StreetViewStatus.OK) {
                jQuery("#panoError").html("No street view available");
                myPano.setVisible(false);
              }
            }
          );
        }
      }

      function handlePanoMove(location)
      {
        ShowLatLong(myPano.getPosition());
      }
      function copyData()
      {
	var lat=document.getElementById('latitude').value;
	var long=document.getElementById('longitude').value;
	document.getElementById('latitude').value=lat;
	document.getElementById('longitude').value=long;
      }
     function reinitialize()
     {
	google.maps.event.trigger(map, 'resize');
     }
  /* ]]> */
  </script>
EOF;
	    }
		}
	    else
	    {
		$script ="";
	    }

            $html.='<table class="table table-striped mymaplocation">
			<tbody><tr style="display:none;">
			<td class="titleCell" ><label>' . $form->getLabel('catid') . '</label></td>
									<td class="fieldCell catid">
			' . str_replace('catid', 'mapcatid', $form->getInput('catid')) . '</td>
						</tr>';
				$html.='</table>';
						if($autogeocode==1)
						{
			
			$html.='<script src="//maps.google.com/maps/api/js?libraries=places&amp;sensor=false'.$key.'" type="text/javascript"></script>
  	<script src="' . JURI::root() . 'administrator/components/com_mymaplocations/assets/site.js" type="text/javascript"></script>
	
 <input id="postcode" style="width:250px;" type="text" class="search-query"/><input type="button" onclick="Geocode()" value="' . JTEXT::_("COM_MYMAPLOCATIONS_FORM_LBL_STORE_SEARCH") . '"  class="btn"/>
 	<div class="control-group">
							<div class="navbar-form pull-left">
	<label><span class="label label-info">' . JTEXT::_("COM_MYMAPLOCATIONS_FORM_LBL_STORE_LATITUDE") . '</span></label><input type="text" name="latitude" id="latitude" value="'.$form->getValue('latitude').'"  />
	</div>
							<div class="navbar-form pull-left">
	<label><span class="label label-info"> ' . JTEXT::_("COM_MYMAPLOCATIONS_FORM_LBL_STORE_LONGITUDE") . '</span></label><input type="text" name="longitude" id="longitude" value="'.$form->getValue('longitude').'"  />
							</div></div>
	<div id="map" style="width: 300px; height: 300px;clear:both;"></div>' . $script ;
						}
	if($this->params->get('usedefault',0)==0)
						{
							
	$html.='<table class="table table-striped mymaplocation"><tr>
                            <td class="titleCell"><label>' . $form->getLabel('address') . '</label></td>
									<td class="fieldCell">
			<textarea name="address" id="address" cols="10" rows="10" >'.$form->getValue('address').'</textarea></td>
								</tr>
								<tr>
                            <td class="titleCell"><label>
                        ' . $form->getLabel('town') . '</label></td>
			<td class="fieldCell">
			<input type="text" name="town" id="town" value="'.$form->getValue('town').'" /></td>
								</tr>
								<tr>
                            <td class="titleCell"><label>' . $form->getLabel('locationstate') . '</label></td>
			<td class="fieldCell">
			<input type="text" name="locationstate" id="locationstate" value="'.$form->getValue('locationstate').'" /></td>
								</tr>
								<tr>
                            <td class="titleCell"><label>' . $form->getLabel('country') . '</label></td>
			<td class="fieldCell">
			<input type="text" name="country" id="country" value="' . $form->getValue('country') . '" /></td>
								</tr>
								<tr>
                            <td class="titleCell"><label>' . $form->getLabel('postal') . '</label></td>
			<td class="fieldCell">
			<input type="text" name="postal" id="postal" value="' . $form->getValue('postal') . '" /></td>
								</tr>
			<tr>
                            <td class="titleCell"><label>' . $form->getLabel('phone') . '</label></td>
			<td class="fieldCell">
			<input type="text" name="phone" id="phone" value="' . $form->getValue('phone') . '" /></td>
								</tr><tr>
                            <td class="titleCell"><label>' . $form->getLabel('hours') . '</label></td>
			<td class="fieldCell">
			<textarea name="hours" id="hours" cols="10" rows="10" >' . $form->getValue('hours') . '</textarea></td>
								</tr>';
								if($this->params->get('usedefault',0)==0)
						{
		$html.='<tr rowspan="2">
				<td class="fieldCell" colspan="2">
				<label>

			' . $form->getLabel('description') . '</label>
			
			' . $form->getInput('description') . '</td></tr>';
						}
								$html.='</table>';
			}
								
	
	return $html;
	}
	
	function saveMMLField($row,$isNew)
	{
		$mapitem=array();
		$mapdata = $row;
		$db = JFactory::getDBO();
		$autogeocode=$this->params->get('autogeocode');
		if($isNew==1)
		{
		$db = JFactory::getDBO();
		$sql = "select id from #__mymaplocations_location where component=" . $db->Quote('com_comprofiler') . "AND extra_id=" . $db->Quote($row['id']);
		$db->setQuery($sql);
		$mapitem = $db->loadObject();

		}
		$type = 'location';
		$prefix = 'MyMaplocationsTable';
		$config = array();
		$table = JTable::getInstance($type, $prefix, $config);
		
		 if (!empty($mapitem->id)) {
		$mapdata['id'] = $mapitem->id;
			} else {
		    unset($mapdata['id']);
		}
		
		$mapdata['name'] = $row['id'] . '-' . $row['username'];
		$mapdata['alias'] = $row['id'] . '-' . $row['username'];
		$mapdata['catid'] = $mapdata['mapcatid'];
		$mapdata['component'] = 'com_comprofiler';
		$mapdata['extra_id'] = $row['id'];
		$mapdata['description']=JFactory::getApplication()->input->post->get('description',null,'RAW');
		if($autogeocode==0)
		{
			$address=array();
			if($this->params->get('usedefault',0)==0)
			{
				if(!empty($mapdata['address']))
				$address[]=$mapdata['address'];
				if(!empty($mapdata['town']))
				$address[]=$mapdata['town'];
				if(!empty($mapdata['locationstate']))
				$address[]=$mapdata['locationstate'];
				if(!empty($mapdata['country']))
				$address[]=$mapdata['country'];
				if(!empty($mapdata['postal']))
				$address[]=$mapdata['postal'];				
			}
			else
			{
				$db = JFactory::getDBO();
				  if(empty($this->params))
                               {
                                return ;
                               }
							   
				if(($this->params->get('address')))
				$condition[]=$this->params->get('address');
				if(($this->params->get('city')))
				$condition[]=$this->params->get('city');
				if(($this->params->get('locationstate')))
				$condition[]=$this->params->get('locationstate');
				if(($this->params->get('country')))
				$condition[]=$this->params->get('country');
				if(($this->params->get('postal')))
				$condition[]=$this->params->get('postal');
				$sql = "SELECT fieldid,name from  #__comprofiler_fields where fieldid IN (".implode(',', $condition).") ORDER BY FIELD( fieldid,".implode(',', $condition).")";
				$db->setQuery($sql);
				$fieldDatas = $db->loadObjectList();
				
				foreach($fieldDatas  as $fieldData)
				{
				$address[]=$mapdata[$fieldData->name];
				}
				
			}
			$addr=@MyMaplocationsHelper::getLatLongFromPostcode(implode(',', $address));
			$mapdata['latitude']=$addr['lat'];
			$mapdata['longitude']=$addr['lang'];
			$mapdata['address']=implode(',', $address);
			$mapdata['town']="";
			$mapdata['locationstate']="";
			$mapdata['postal']="";
			$mapdata['country']="";
			$mapdata['phone']="";
			$mapdata['hours']="";
			$mapdata['state']=1;
			
			
		}
		$table->bind($mapdata);

        if (!$table->check()) {

            JFactory::getApplication()->enqueueMessage($table->getError(), 'error');
        }
        if (!$table->store()) {
            JFactory::getApplication()->enqueueMessage($table->getError(), 'error');
        }
	
        
	}
	

	function getDisplayTab( $tab, $user, $ui) {
		if(!$this->installed)
		{
		return;
		}
		
		$return="My Map Locations";
	 $db = JFactory::getDBO();
	 $doc = JFactory::getDocument();
	$style = '.mml_logo,#map_canvas img {'
        . 'max-width: '.$this->params->get("max_height").';'
        . 'max-height:'.$this->params->get("max_width").';'
        . '}'; 
	$doc->addStyleDeclaration( $style );
	 if($this->params->get('usedefault',0)==0)
	{
        $sql = "SELECT a.*,k.firstname as name FROM #__mymaplocations_location AS a LEFT JOIN #__comprofiler AS k ON k.id = a.extra_id where k.approved=1 AND k.confirmed=1 AND a.component=" . $db->Quote('com_comprofiler') . "  AND a.extra_id=" . $db->Quote($user->user_id);
	$db->setQuery($sql);
        $mapitem = $db->loadObject();
	}
	else
	{
		$sql = "SELECT a.latitude,a.longitude,k.firstname as name FROM #__mymaplocations_location AS a LEFT JOIN #__comprofiler AS k ON k.id = a.extra_id where k.approved=1 AND k.confirmed=1 AND a.component=" . $db->Quote('com_comprofiler') . "  AND a.extra_id=" . $db->Quote($user->user_id);
		$db->setQuery($sql);
		$mapitem = $db->loadObject();
		
		if($mapitem===null)
		{
			return;
		}
		$extra_fields=array();
		$condition=array();
		if($this->params->get('extra_fields'))
		{
			$extra_fields=explode( '|*|',$this->params->get('extra_fields'));
			foreach($extra_fields as $extra_field)
			{
				$condition[]=$extra_field;
			}
		}
		if(($this->params->get('address')))
		$condition[]=$this->params->get('address');
		if(($this->params->get('city')))
		$condition[]=$this->params->get('city');
		if(($this->params->get('locationstate')))
		$condition[]=$this->params->get('locationstate');
		if(($this->params->get('country')))
		$condition[]=$this->params->get('country');
		if(($this->params->get('postal')))
		$condition[]=$this->params->get('postal');
		if(($this->params->get('phone')))
		$condition[]=$this->params->get('phone');
		
		$sql = "SELECT fieldid,name from  #__comprofiler_fields where fieldid IN (".implode(',', $condition).")";
		$db->setQuery($sql);
		$fieldDatas = $db->loadObjectList();
		$mapitem->extra_fields="";
		foreach($fieldDatas  as $fieldData)
		{
			$string=$fieldData->name;
			if(($extra_fields)&&(in_array($fieldData->fieldid,$extra_fields)))
			{
				$mapitem->extra_fields.=strip_tags($user->$string,'<a><br/>')."<br/>";
			}
			if($this->params->get('address')==$fieldData->fieldid)
			{
				$mapitem->address.=$user->$string;
			}
			if($this->params->get('city')==$fieldData->fieldid)
			{
				$mapitem->town=$user->$string;
			}
			if($this->params->get('locationstate')==$fieldData->fieldid)
			{
				$mapitem->locationstate=$user->$string;
			}
			if($this->params->get('country')==$fieldData->fieldid)
			{
				$mapitem->country=$user->$string;
			}
			if($this->params->get('postal')==$fieldData->fieldid)
			{
				$mapitem->postal=$user->$string;
			}
			if($this->params->get('phone')==$fieldData->fieldid)
			{
				$mapitem->phone=$user->$string;
			}
			if($this->params->get('hours')==$fieldData->fieldid)
			{
				$mapitem->hours=$user->$string;
			}
			
		}
	}
	if(empty($mapitem))
	{
		return;
	}
	if(@$mapitem->extra_fields)
	{
		$mapitem->address=$mapitem->extra_fields.$mapitem->address;
	}
	$cbUser = CBuser::getInstance((int)$user->user_id);
	$avatar = $cbUser->getField('avatar', null, 'csv', 'none', 'profile');
	$mapitem->name=MyMaplocationsHelper::getNameFormatOnline($cbUser);
	$mapitem->logo=$avatar;
	$width=$this->params->get('width');
	$height=$this->params->get('height');
	$zoom=$this->params->get('zoom');
	$type=$this->params->get('type');
            $mapitems[0] = $mapitem;
            $map = MyMaplocationsHelper::createMap($mapitems, $width, $height, $zoom, $type);
			$output="";
             $output = ' <div class="row-fluid mymaplocation" style="width:100%;"><div class="span12"><div class="locationsearch" id="locationsearch"><span property="v:name"><h3>' . $mapitem->name . '</h3></span>';
            $address = MyMaplocationsHelper::formatAddress($mapitem);
            $output.= $map . '
    <div xmlns:v="http://rdf.data-vocabulary.org/#" typeof="v:Organization" class="mmladdress">
   <div rel="v:address" class="even">
      <address typeof="v:Address">
	' . $address . '
      </address>
   </div>
   <div rel="v:geo">
      <span typeof="v:Geo">
         <span property="v:latitude" content="' . $mapitem->latitude . '"></span>
         <span property="v:longitude" content="' . $mapitem->longitude . '"></span>
      </span>
   </div>
 </div>
    <div class="description">
      ' . $mapitem->description . '
      </div>
    </div> </div></div><div class="clr"></div>';
         
         $output.="<script type='text/javascript'> cbjQuery(document).ready(function(){
	 cbjQuery('.cbTabsNav a').click(function(e){
	var target=(cbjQuery(e.target).attr('href'));
		if(target=='#cbtabpane".$tab->tabid."') {
			reinitialize_com_comprofiler_".$mapitem->id."();
	    };
	    });});</script>";
        return $output;
		}

	function saveRegistrationTab($tab, &$user, $ui, $postdata) {
		if(empty($user->user_id) OR !$this->installed) return;
		//We are on save registration
		$postdata['id']=$user->user_id;
		$this->saveMMLField($postdata,0);
		return;
	}

	function userDelete($user, $success) {
		if(!$this->installed){ return $this->errorMessage;}
			
		if (!$success) return;
		$db = JFactory::getDBO();
		$sql = "SELECT id FROM #__mymaplocations_location where component=" . $db->Quote('com_comprofiler') . "  AND extra_id=" . $db->Quote($user->user_id);
		$db->setQuery($sql);
        $data = $db->loadObject();
		$type = 'location';
		$prefix = 'MyMaplocationsTable';
		$config = array();
		$table = JTable::getInstance($type, $prefix, $config);
		$table->delete( $data->id );
		//Delete user Query here
	}

	function userActivated($user, $success) {
		if(!$this->installed){ return $this->errorMessage;}

		if (!$success) return;
		//User activation here

		return;
	}


	function getEditTab( $tab, $user, $ui) {
		if(!$this->installed){ return $this->errorMessage;}
	
		$html=$this->getMMLField($user->id);
		$html.="<script type='text/javascript'> cbjQuery(document).ready(function(){
	 cbjQuery('.cbTabsNav a').click(function(e){
	var target=(cbjQuery(e.target).attr('href'));
		if(target=='#cbtabpane".$tab->tabid."') {
			reinitialize();
	    };
	    });});</script>";
	    
		//Edit Tab here
		return $html;
	}

	function saveEditTab($tab, &$user, $ui, $postdata) {
		
		$this->saveMMLField($postdata,1);
		return;
		//Save Tab here
	}

}

